String Mitteilung = "";

String urlencode(String str)
{
  String encodedString = "";
  char c;
  char code0;
  char code1;
  char code2;
  for (int i = 0; i < str.length(); i++) {
    c = str.charAt(i);
    if (c == ' ') {
      encodedString += '+';
    } else if (isalnum(c)) {
      encodedString += c;
    } else {
      code1 = (c & 0xf) + '0';
      if ((c & 0xf) > 9) {
        code1 = (c & 0xf) - 10 + 'A';
      }
      c = (c >> 4) & 0xf;
      code0 = c + '0';
      if (c > 9) {
        code0 = c - 10 + 'A';
      }
      code2 = '\0';
      encodedString += '%';
      encodedString += code0;
      encodedString += code1;
      //encodedString+=code2;
    }
    yield();
  }
  return encodedString;

}



unsigned int hexToDec(String hexString) {

  unsigned int decValue = 0;
  int nextInt;

  for (int i = 0; i < hexString.length(); i++) {

    nextInt = int(hexString.charAt(i));
    if (nextInt >= 48 && nextInt <= 57) nextInt = map(nextInt, 48, 57, 0, 9);
    if (nextInt >= 65 && nextInt <= 70) nextInt = map(nextInt, 65, 70, 10, 15);
    if (nextInt >= 97 && nextInt <= 102) nextInt = map(nextInt, 97, 102, 10, 15);
    nextInt = constrain(nextInt, 0, 15);

    decValue = (decValue * 16) + nextInt;
  }

  return decValue;
}

void LeseEeprom(char *daten, int lenge)
{
  char a;
  do {
    a = EEPROM.read(z);
    *daten = a;
    daten++;
    z++;
    lenge--;
    if (!lenge)break;
  }
  while (a);
}

void LeseEepromStr(String *daten, int lenge)
{
  char a;
  *daten = "";
  do {
    a = EEPROM.read(z);
    *daten += String(a);
    z++;
    lenge--;
    if (!lenge)break;
  } while (a);
}

void SchreibeEeprom (String k)
{
  int i = 0, blja = 64;
  int  pos, wert;
  char Buchstabe;
  String HexZahl, ersatz = "f";
  k.replace("+", " ");

  while (blja--)
  {
    pos = k.indexOf('%');   // Kodierte zeichen enthalten
    if (pos < 0)break;
    HexZahl = k.substring(pos + 1, pos + 3); // Position finden
    wert = hexToDec(HexZahl);
    ersatz[0] = wert;               //Int to Chahr im String
    HexZahl = "%" + HexZahl;        //Suchmuster finden
    k.replace(HexZahl, ersatz);
  }

  while (k[i])
  {
    EEPROM.write(z, k[i]);
    z++;
    i++;
  }
  EEPROM.write(z, '\0');
  z++;
}



void Ereignis_Index()			// Wird ausgeuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  server.send(200, "text/html", WEBset);
}

void Ereignis_daten()			// Wird ausgeuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  int i;
  if (ssid[0] == 255) ssid[0] = 0;            // Wenn speicher leer alles auf 0
  if (passwort[0] == 255) passwort[0] = 0;
  if (apiKey[0] == 255) apiKey = "";
  if (nachricht[0] == 255) nachricht = "";

  String temp = "";              // Sternhen einfГЇВїВЅgen beim Passwortanzeige
  String pass = String(passwort);
  if (pass.length() > 2) for (i = 1; i < (pass.length() - 1); i++) pass[i] = '*';

  temp += "var ssid1=\"" + String(ssid) + "\"\r\n";
  temp += "var pass1=\"" + pass + "\"\r\n";
  temp += "var url1=\"" + apiKey + "\"\r\n";
  temp += "var nachricht=\"" + nachricht + "\"\r\n";
  temp += "var Mitteilung=\"" + Mitteilung + "\"\r\n";
  temp += "var Firmware=\"1.0\"\r\n";
  temp += "var ChipID1=\"" + String(ESPm.getFlashChipId()) + "\"\r\n";
  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/plain", temp);
}

void formular()			// Wird ausgeuehrt wenn "http://<ip address>/setup.php"
{
  z = 0;
  SchreibeEeprom (server.arg("ssid"));
  String temp1 = server.arg("passwort");
  if (temp1[2] != '*') SchreibeEeprom (server.arg("passwort")); // wenn mit *
  else SchreibeEeprom (passwort);                   // dann geladene pass abspeichern
  SchreibeEeprom (server.arg("url"));
  SchreibeEeprom (server.arg("nachricht"));
  EEPROM.commit();

  z = 0;                        // EEPROM Star den Datensatzes
  LeseEeprom(ssid, sizeof(ssid));
  LeseEeprom(passwort, sizeof(passwort));
  LeseEepromStr(&apiKey, 100);
  LeseEepromStr(&nachricht, 100);
  Mitteilung = "Gespeichert!";
  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/html", WEBset);
}


void ADC_Kalibrieren()
{
  uint ADCValue = ESPm.getVcc();         //  Ubat messen
  String kal = server.arg("kal");         // GET-Argument empfangen
  String Meldung = "";
  char *zeichen;
  if (kal == "3.4")
  {
    ADCKal34 = ADCValue;
    zeichen = reinterpret_cast<char*>(&ADCKal34);
    EEPROM.write(240, *zeichen);
    zeichen++;
    EEPROM.write(241, *zeichen);

    EEPROM.commit();
    Meldung = "Kalibrationswert fuer 3,4V=" + String(ADCKal34);
  }
  if (kal == "2.4")
  {
    if (ADCKal34 <= ADCValue)
    {
      Meldung = "Fehler! Kein unterschied zwischen Kalibrationswerten";
    }
    else
    {
      ADCKal24 = ADCValue;
      zeichen = reinterpret_cast<char*>(&ADCKal24);
      EEPROM.write(242, *zeichen);
      zeichen++;
      EEPROM.write(243, *zeichen);
      EEPROM.commit();
      Meldung = "Kalibrationswert fuer 2,4V=" + String(ADCKal24);
    }
  }
  unsigned int faktor = ADCKal34 - ADCKal24;
  int Korrekturwert = 2.4 * faktor - ADCKal24;
  float ADCfloat = float(ADCValue + Korrekturwert);
  ADCfloat = ADCfloat / faktor;

  String temp = "<!DOCTYPE html><html lang=\"en\">\r\n\
<head>\
<meta charset=\"utf-8\">\r\n\
<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">\
<title>ADC Kalibrieren</title>\r\n\
</head>\r\n\
<body>\r\n";
  temp += "ADC Wert: " + String(ADCValue) + " , ADC Spannung: " + String(ADCfloat, 2) + "V<br><br>\r\n" ;
  temp += "Korrekturwert: " + String(Korrekturwert) + " , Korrekturfaktor: " + String(faktor) + "<br><br>\r\n" ;
  temp += "<li><a href=\"adc.php?kal=3.4\">Kalibrieren mit 3,4V</a></li><br>\r\n";
  temp += "<li><a href=\"adc.php?kal=2.4\">Kalibrieren mit 2,4V</a></li> <br>\r\n";
  temp += "<li><a href=\"adc.php\">Noch mal messen</a></li> <br><br>\r\n";
  temp += "<strong>" + Meldung + "</strong>";
  temp += "</body>\r\n\
</html>";

  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/html", temp);
}

void handleNotFound() {

  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += ( server.method() == HTTP_GET ) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";

  for ( uint8_t i = 0; i < server.args(); i++ ) {
    message += " " + server.argName ( i ) + ": " + server.arg ( i ) + "\n";
  }

  server.send ( 404, "text/plain", message );
}


void Einstellen()
{

  // Serial.println("Einstellen");
  EEPROM.begin(250);                                 // EEPROM initialisieren mit 200 Byts
  z = 0;                        // EEPROM Star den Datensatzes
  LeseEeprom(ssid, sizeof(ssid));
  LeseEeprom(passwort, sizeof(passwort));
  LeseEepromStr(&apiKey, 100);
  LeseEepromStr(&nachricht, 100);
  //----------------- ADC - Kalibrationswerte einlesen -------------------------------------------
  char *zeichen;
  zeichen = reinterpret_cast<char*>(&ADCKal34);
  *zeichen = EEPROM.read(240);
  zeichen++;
  *zeichen = EEPROM.read(241);
  zeichen = reinterpret_cast<char*>(&ADCKal24);
  *zeichen = EEPROM.read(242);
  zeichen++;
  *zeichen = EEPROM.read(243);
  if (ADCKal34 > 5000 || ADCKal34 < 2000)ADCKal34 = 3400;
  if (ADCKal24 > 5000 || ADCKal24 < 1500)ADCKal24 = 2400;
  //----------------- Ende ADC - Kalibrationswerte einlesen -------------------------------------------
  boolean endlos = 1;
  WiFi.mode(WIFI_AP);			// access point modus
  WiFi.softAPConfig(apIP, apIP, IPAddress(255, 255, 255, 0));
  WiFi.softAP("Bodenfeuchtesensor Setup", "tiramisu");	// Name des Wi-Fi netzes
#if defined DNS
  dnsServer.start(DNS_PORT, "*", apIP);
#endif
  delay(500);					// Abwarten 0,5s
  server.onNotFound ( handleNotFound );
  server.on("/", Ereignis_Index);
  server.on("/daten.js", Ereignis_daten);
  server.on("/setup.php", formular);
  server.on("/adc.php", ADC_Kalibrieren);
  server.begin();				// Starte den Server
  while (endlos)
  {
#if defined DNS
    dnsServer.processNextRequest();
#endif
    server.handleClient();
  }
}



